#!/bin/bash
# Script to bundle Perl-Module with Script
# by Andreas Romeyke @ SLUB Dresden

REQUIRED_PERL_MODULE=PAR::Packer
WHAT_TO_BUNDLE=bin/slubsipbuilderbagit.pl
LIB_TO_BUNDLE="-I lib/ -M SLUB::LZA::SIPBuilderBagIt"
BUNDLE_NAME=slubsipbuilder_bundled.pl
BUNDLE_LOG=bundle.log
echo -n "Checking if required module exists… "
# test if module exists
perl -M${REQUIRED_PERL_MODULE} -e ";" > /dev/null 2>&1
if [[ $? -ne 0 ]]; then
  echo "failed! :(" 
  echo "you need to install perl module ${REQUIRED_PERL_MODULE}";
  echo "HINT: 'cpanm ${REQUIRED_PERL_MODULE}' could help";
  exit 1;
else
  echo "fine :)"
fi
echo -n "Trying to bundle… "
# -c .... check dependencies via 'perl -c ...'
# -P .... build a Perl-script bundle
# -o .... output as
# -d .... do not include perl interpreter
#VERBOSE=1 pp ${LIB_TO_BUNDLE} -x -c -d -P -r -z 9 -o ${BUNDLE_NAME} ${WHAT_TO_BUNDLE} > ${BUNDLE_LOG} 2>&1
pp -o ${BUNDLE_NAME} -P -u -d ${LIB_TO_BUNDLE} ${WHAT_TO_BUNDLE} > ${BUNDLE_LOG} 2>&1
if [[ $? -eq 0 ]]; then 
  echo "fine :)"
  echo "Successfully build bundles in ${BUNDLE_NAME}"
  rm -f ${BUNDLE_LOG}
else
  echo "failed! :'("
  echo "Something was wrong in bundling to ${BUNDLE_NAME}"
  echo "Check ${BUNDLE_LOG} for details"
fi
