#!/usr/bin/bash
# Release build under Debian 11

DATE="$(date +%F\ %T)"
BRANCH="$(git branch --show-current)"
VERSION="$(git rev-list HEAD --count)-$BRANCH"
BUILD_ZIP="SLUB_SIP_Builder.version-${VERSION}.zip"
BUILD_DIR="build"
BUILD_ROOT="${BUILD_DIR}/SLUB_SIP_Builder"
BUILD_SCRIPT=$(basename "$0")
rm -rf "${BUILD_ZIP}"
rm -rf "${BUILD_DIR}"
mkdir -p "${BUILD_ROOT}"
rsync -av --exclude='.git'          --exclude='.idea'       --exclude='_Deparsed_XSubs.pm' \
          --exclude='.gitignore'    --exclude='tmp' \       --exclude='*.zip' \
          --exclude="${BUILD_SCRIPT}" --exclude="${BUILD_DIR}/" \
          --exclude="*.iml" ./ "${BUILD_ROOT}" --exclude='build*'
sed -i "/^#.*FILE:.*/a \
#\n\
#      VERSION: ${VERSION}\n\
# RELEASE DATE: ${DATE}" ${BUILD_ROOT}/bin/slubsipbuilderbagit.pl
cd "${BUILD_DIR}" ||exit; zip -r ../"${BUILD_ZIP}" .; cd ..
rm -rf "${BUILD_DIR}"
if [[ -e "${BUILD_ZIP}" ]]; then
  echo "release archived in file '${BUILD_ZIP}' :)"
else
  echo "something goes wrong :("
fi
